﻿@using Veloverleih.Shared.Models
@inject HttpClient Http
@inject NavigationManager NavigationManager
@inject LoginStateService loginStateService
@using Veloverleih.Client.State
@using Veloverleih.Shared
@implements IDisposable



<div class="col">
    <div class="card shadow-sm">
        <img src="@(Bicycle.Thumbnail)" class="card-img-top" alt="Bicycle Image of @Bicycle.Name" />
        <div class="card-body">
            <h5 class="card-title">@Bicycle.Name</h5>
            <h6 class="card-subtitle mb-2 text-muted">Marke: @Bicycle.Marke</h6>
            <ul class="list-group list-group-flush">
                <li class="list-group-item">Tagespreis: @Bicycle.Preis.ToString("C")</li>
                <li class="list-group-item">Ort: @Bicycle.Ort</li>
            </ul>
            <div class="d-flex justify-content-between align-items-center">
                <div class="btn-group">
                    <button type="button" id="@(Bicycle.Id)" @onclick="DetailsButtonClicked" class="btn btn-sm btn-outline-secondary">Details</button>
                    @{
                        if (selectedUser != Users.Login)
                        {
                            <button type="button" class="btn btn-sm btn-outline-secondary">Reserve</button>
                        }
                    }
                </div>
            </div>
        </div>
    </div>
</div>

@code {
    [Parameter]
    public BicycleModel Bicycle { get; set; } = new BicycleModel();
    private Users selectedUser;

    protected override async Task OnInitializedAsync()
    {
        loginStateService.OnStateChange += StateHasChanged;
        selectedUser = loginStateService.User;
    }

    private void DetailsButtonClicked(MouseEventArgs args)
    {
       NavigationManager.NavigateTo($"/bicycledetail/{Bicycle.Id}");
    }

    public void Dispose()
    {
        loginStateService.OnStateChange -= StateHasChanged;
    }
}
